unit uFenster;
// **********************************************************************
(* K L A S S E :  FENSTER                                               *)
(* -------------------------------------------------------------------- *)
(* Version     :  0.9			                                              *)
(* Autor       :  (c) Siegfried Spolwig, OSZ Handel, 10997              *)
(*                                                                      *)
(* Aufgabe     : Veranschaulichung des Datenflusses bei M-V-C           *)
(* Compiler    : DELPHI 5.0                                             *)
(* Aenderung   : V. 1.0 - 28-AUG-98																			*)
(*						 :    0.9	-	22-AUG-01		Tperson	                          *)
// **********************************************************************

interface
// ======================================================================
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons,
  uPerson;


type
  TFensterFrm = class(TForm)
    GroesseLbl: TLabel;
    GroesseEdt: TEdit;
    GewichtLbl: TLabel;
    GewichtEdt: TEdit;
    BMILbl		: TLabel;
    BmiEdt		: TEdit;
    NameEdt		: TEdit;
    NameLbl   : TLabel;
    SteuerPnl	: TPanel;
    OKBtn			: TButton;
    AnzeigeBtn: TSpeedButton;
    EndeBtn		: TButton;
    EssBtn    : TButton;

    procedure OKBtnClick (Sender: TObject);
    procedure FormCreate (Sender: TObject);
    procedure EndeBtnClick(Sender: TObject);
    procedure AnzeigeBtnClick(Sender: TObject);
    procedure EssBtnClick(Sender: TObject);

   private
    procedure Init;
    procedure DatenAktualisieren(var Pers : TPerson);  // -- hier der Datentransport
    procedure MaskeAktualisieren(Pers : TPerson);


   public
  end;

var
  FensterFrm: TFensterFrm;   // --- das aktuelle Exemplar vom Fenster,
  													 //    	in dem alles luft
                             // --- das Objekt PERSON
  AktuellePerson : TPerson;

implementation
{$R *.DFM}
// ======================================================================


procedure TFensterFrm.FormCreate(Sender: TObject);
// ----------------------------------------------------------------------
begin
  AktuellePerson := TPerson.Create;
  AktuellePerson.Init;
  FensterFrm.Init;
end;

procedure TFensterFrm.Init;
// ----------------------------------------------------------------------
begin
	NameEdt.Text 	  := '';
  GroesseEdt.Text := '';
  GewichtEdt.Text := '';
  BmiEdt.Text		 	:= '';
end;

		            // --- hier luft der DATENTRANSPORT -------
procedure TFensterFrm.DatenAktualisieren(var Pers : TPerson);
// ----------------------------------------------------------------------
begin
	Pers.SetName (NameEdt.Text);
  Pers.SetGroesse (StrToFloat (GroesseEdt.Text));
  Pers.SetGewicht (StrToFloat (GewichtEdt.Text));
end;


procedure TFensterFrm.MaskeAktualisieren(Pers : TPerson);
// ----------------------------------------------------------------------
begin
  NameEdt.Text 		:= Pers.GetName;
  GroesseEdt.Text := FloatToStr (Pers.GetGroesse);
  GewichtEdt.Text := FloatToStr (Pers.GetGewicht);
  BmiEdt.Text    	:= FloatToStr (Pers.HatBMI);
end;




//  hier beginnen die EREIGNISPROZEDUREN zur STEUERUNG (Control)


procedure TFensterFrm.OKBtnClick(Sender: TObject);
// ----------------------------------------------------------------------

begin
  DatenAktualisieren(AktuellePerson);
  Init;
end;


procedure TFensterFrm.EndeBtnClick(Sender: TObject);
// ----------------------------------------------------------------------
begin
  Close;
end;

procedure TFensterFrm.AnzeigeBtnClick(Sender: TObject);
begin
  MaskeAktualisieren(AktuellePerson);
end;

procedure TFensterFrm.EssBtnClick(Sender: TObject);
begin
  AktuellePerson.Abnehmen;
end;

end. // ------ UNIT -------
