unit uPerson;
(* ******************************************************************** *)
(*                                                                      *)
(* K L A S S E : TPerson                                                *)
(* -------------------------------------------------------------------- *)
(* Version     : 0.9                                                		*)
(* Autor       : S. Spolwig, OSZ-Handel I, 10997 Berlin                 *)
(*                                                                      *)
(* Aufgabe     : bildet das Objekt Person ab und berechnet BMI.         *)
(*                                                                      *)
(* Compiler    : DELPHI 5.0                                             *)
(* Aenderung   : V. 0.9  15-AUG-01                                      *)
(* ******************************************************************** *)

interface
(* ==================================================================== *)
type
  TPerson = class(TObject)
	 private
		Name		: string;
    Groesse : real;
    Gewicht : real;
   public
    constructor Create;
	  procedure Init;
    procedure SetName (n : string);
    function  GetName : string;
    procedure SetGroesse (gr : real);
    function  GetGroesse : real;
    procedure SetGewicht (gw : real);
    function  GetGewicht : real;

    function HatBMI: real;
    procedure Abnehmen;
  end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse     : TObject
Bezugsklassen  : -

Methoden
--------
Create
  Auftrag: Person und Adresse erzeugen und Initialisieren
  vorher : -
  nachher: Person ist erzeugt, alle Datenfelder sind leer.

Init
  Auftrag: Person Initialisieren
  vorher : ist erzeugt
  nachher: alle Datenfelder sind leer.

Set...
  Auftrag: Attribut schreiben
  vorher : Person ist vorhanden.
  nachher: Attribut ist gesetzt

Get...
  Anfrage: Attribut aus dem Objekt lesen
  vorher : Person ist vorhanden.
  nachher: -

HatBMI: real;
  Anfrage: nach dem BMI-Wert
  vorher : Person ist init.
  nachher: -

Abnehmen
  Auftrag: Gewicht jeweils um 5 erhhen
  vorher : ist erzeugt
  nachher: neues Gewicht
        
----------------------------------------------------------------------- *)

implementation
(* ==================================================================== *)

constructor TPerson.Create;
(* -------------------------------------------------------------------- *)
begin
  inherited Create;  // zuerst das geerbte Object erzeugen
  Init;
end;

procedure TPerson.Init;
(* ----------------------------------------- *)
begin
  Name		:= '';
  Groesse := 0;
  Gewicht := 0;
end;

procedure TPerson.SetName (n : string);
(* ----------------------------------------- *)
begin
  Name := n;
end;

function TPerson.GetName : string;
(* ----------------------------------------- *)
begin
  Result := Name;
end;

procedure TPerson.SetGroesse (gr : real);
(* ----------------------------------------- *)
begin
  Groesse := gr;
end;

function TPerson.GetGroesse: real;
(* ----------------------------------------- *)
begin
  Result := Groesse;
end;

procedure TPerson.SetGewicht (gw : real);
(* ----------------------------------------- *)
begin
  Gewicht := gw;
end;

function TPerson.GetGewicht: real;
(* ----------------------------------------- *)
begin
  Result := Gewicht;
end;

function TPerson.HatBMI: real;
(* ----------------------------------------- *)
begin
  result := Gewicht / ( Groesse * Groesse);
end;

procedure TPerson.Abnehmen;
(* ----------------------------------------- *)
begin
  Gewicht := Gewicht - 1;
end;

END. // ----- UNIT -------
